<template>
  <div>

    <b-card
      no-body
      class="mb-0"
    >
    
      <br>
      <activitie-view-info-card :activitieData="activitie" @success="reload2"></activitie-view-info-card>
      <hr>
      <b-card title="Avances de la actividad" v-if="activitie.status">
        <advances-table v-if="activitie.percentage_advance != null" :percentage_advance="activitie.percentage_advance" :status="activitie.status.name" :advances="advances" @success="reload"></advances-table>

      </b-card>

      <br>
      <hr>
      <b-card class="activities-table">
        
        <activities-table ></activities-table>
        
      </b-card>
    
    </b-card>
    
   

  </div>
</template>

<script>
import {
  BSidebar, BForm, BFormGroup, BFormInput, BFormInvalidFeedback, BButton,BTab, BTabs, BCard,BCardText, 
  BAlert, BLink,BFormSelect,BFormSelectOption,
} from 'bootstrap-vue'
import ActivitieViewInfoCard from './ActivitieViewInfoCard.vue'
import ActivitiesTable from '../ActivitiesTable.vue'
import AdvancesTable from './AdvancesTable.vue'
export default {
  name:'activitie-view',
  props: {
  },
  components: {
    BTab,
    BTabs,
    BCard,
    BCardText,
    BAlert,
    BLink,
    BSidebar,
    BForm,
    BFormGroup,
    BFormInput,
    BFormInvalidFeedback,
    BButton,
    BFormSelect,
    BFormSelectOption,
    ActivitieViewInfoCard,
    ActivitiesTable,
    AdvancesTable

 
  },

  data(){
    return{
      activitie:{},
      projectMembers:[],
      advances:[]

    }
  },
  methods:{
    getActivitieData(){
      this.$http.get('project/activities/show',{params:{activitie:this.$route.params.activitie}}).then(res=>{
        this.activitie = res.data.activitie
      }).catch(err=>{
        console.log(err)
      })
    },
    getProjectMembers(){
      this.$http.get('project/activities/showProjectMembers',{params:{project:this.$route.params.id}}).then(res=>{
        this.projectMembers = res.data.members
      }).catch(err=>{
        console.log(err)
      })
    },
    cancel(){
      this.$router.push({ name: 'apps-project-activities-list', params:{id:this.$route.params.id} })
    },
    getAdvances(){
      this.$http.get('activities/advances',{params:{id:this.$route.params.activitie}}).then(res=>{
        this.advances = res.data.avances
      }).catch(err=>{
        console.log(err)
      })
    },
    reload(e){
          if(e){
            this.getAdvances()
            this.getActivitieData()
          }
    },
    reload2(e){
          if(e){
            this.getActivitieData()
          }
    },
    beforeEnter(){
        let userData = JSON.parse(localStorage.userData)
        if(this.activitie.project){
          if ((this.hasPermission('show_project_activities') || userData.id === this.activitie.project.manager_id || userData.id === this.activitie.manager_id )) {
            return true
          }else {
            this.$router.push({name: "misc-not-authorized"}) 
          }
        }
    }
  },

    mounted(){
      this.getProjectMembers()
      this.getActivitieData()
      this.getAdvances()
    }



}
</script>

<style>

</style>
